/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/MessageAck.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_MESSAGEACK_HPP
#define CASTOR_MESSAGEACK_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  /**
   * class MessageAck
   * Acknowledgement message in the request handler protocol.
   */
  class MessageAck : public virtual IObject {

  public:

    /**
     * Empty Constructor
     */
    MessageAck() throw();

    /**
     * Empty Destructor
     */
    virtual ~MessageAck() throw();

    /**
     * Outputs this object in a human readable format
     * @param stream The stream where to print this object
     * @param indent The indentation to use
     * @param alreadyPrinted The set of objects already printed.
     * This is to avoid looping when printing circular dependencies
     */
    virtual void print(std::ostream& stream,
                       std::string indent,
                       castor::ObjectSet& alreadyPrinted) const;

    /**
     * Outputs this object in a human readable format
     */
    virtual void print() const;

    /**
     * Gets the type of this kind of objects
     */
    static int TYPE();

    /********************************************/
    /* Implementation of IObject abstract class */
    /********************************************/
    /**
     * Gets the type of the object
     */
    virtual int type() const;

    /**
     * virtual method to clone any object
     */
    virtual IObject* clone();

    /*********************************/
    /* End of IObject abstract class */
    /*********************************/
    /**
     * Get the value of m_status
     * Status of the request
     * @return the value of m_status
     */
    bool status() const {
      return m_status;
    }

    /**
     * Set the value of m_status
     * Status of the request
     * @param new_var the new value of m_status
     */
    void setStatus(bool new_var) {
      m_status = new_var;
    }

    /**
     * Get the value of m_errorCode
     * Code of the error if status shows there is one
     * @return the value of m_errorCode
     */
    int errorCode() const {
      return m_errorCode;
    }

    /**
     * Set the value of m_errorCode
     * Code of the error if status shows there is one
     * @param new_var the new value of m_errorCode
     */
    void setErrorCode(int new_var) {
      m_errorCode = new_var;
    }

    /**
     * Get the value of m_errorMessage
     * Error message if status shows there is an error
     * @return the value of m_errorMessage
     */
    std::string errorMessage() const {
      return m_errorMessage;
    }

    /**
     * Set the value of m_errorMessage
     * Error message if status shows there is an error
     * @param new_var the new value of m_errorMessage
     */
    void setErrorMessage(std::string new_var) {
      m_errorMessage = new_var;
    }

    /**
     * Get the value of m_requestId
     * Cuuid associated to the request in case there was no error
     * @return the value of m_requestId
     */
    std::string requestId() const {
      return m_requestId;
    }

    /**
     * Set the value of m_requestId
     * Cuuid associated to the request in case there was no error
     * @param new_var the new value of m_requestId
     */
    void setRequestId(std::string new_var) {
      m_requestId = new_var;
    }

    /**
     * Get the value of m_id
     * The id of this object
     * @return the value of m_id
     */
    u_signed64 id() const {
      return m_id;
    }

    /**
     * Set the value of m_id
     * The id of this object
     * @param new_var the new value of m_id
     */
    void setId(u_signed64 new_var) {
      m_id = new_var;
    }

  private:

    /// Status of the request
    bool m_status;

    /// Code of the error if status shows there is one
    int m_errorCode;

    /// Error message if status shows there is an error
    std::string m_errorMessage;

    /// Cuuid associated to the request in case there was no error
    std::string m_requestId;

    /// The id of this object
    u_signed64 m_id;

  }; /* end of class MessageAck */

} /* end of namespace castor */

#endif // CASTOR_MESSAGEACK_HPP
