/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/io/StreamFileMigratedNotificationStructCnv.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "StreamFileMigratedNotificationStructCnv.hpp"
#include "castor/CnvFactory.hpp"
#include "castor/Constants.hpp"
#include "castor/IAddress.hpp"
#include "castor/ICnvSvc.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectCatalog.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/exception/Exception.hpp"
#include "castor/io/StreamAddress.hpp"
#include "castor/io/StreamBaseCnv.hpp"
#include "castor/io/StreamCnvSvc.hpp"
#include "castor/tape/tapegateway/FileMigratedNotificationStruct.hpp"
#include "castor/tape/tapegateway/FileMigrationReportList.hpp"
#include "castor/tape/tapegateway/PositionCommandCode.hpp"
#include "osdep.h"
#include <string>

//------------------------------------------------------------------------------
// Instantiation of a static factory class - should never be used
//------------------------------------------------------------------------------
static castor::CnvFactory<castor::io::StreamFileMigratedNotificationStructCnv>* s_factoryStreamFileMigratedNotificationStructCnv =
  new castor::CnvFactory<castor::io::StreamFileMigratedNotificationStructCnv>();

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::io::StreamFileMigratedNotificationStructCnv::StreamFileMigratedNotificationStructCnv(castor::ICnvSvc* cnvSvc) :
 StreamBaseCnv(cnvSvc) {}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::io::StreamFileMigratedNotificationStructCnv::~StreamFileMigratedNotificationStructCnv() throw() {
}

//------------------------------------------------------------------------------
// ObjType
//------------------------------------------------------------------------------
unsigned int castor::io::StreamFileMigratedNotificationStructCnv::ObjType() {
  return castor::tape::tapegateway::FileMigratedNotificationStruct::TYPE();
}

//------------------------------------------------------------------------------
// objType
//------------------------------------------------------------------------------
unsigned int castor::io::StreamFileMigratedNotificationStructCnv::objType() const {
  return ObjType();
}

//------------------------------------------------------------------------------
// createRep
//------------------------------------------------------------------------------
void castor::io::StreamFileMigratedNotificationStructCnv::createRep(castor::IAddress* address,
                                                                    castor::IObject* object,
                                                                    bool,
                                                                    unsigned int)
  throw (castor::exception::Exception) {
  castor::tape::tapegateway::FileMigratedNotificationStruct* obj = 
    dynamic_cast<castor::tape::tapegateway::FileMigratedNotificationStruct*>(object);
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  ad->stream() << obj->type();
  ad->stream() << obj->fileTransactionId();
  ad->stream() << obj->nshost();
  ad->stream() << obj->fileid();
  ad->stream() << obj->fseq();
  ad->stream() << obj->fileSize();
  ad->stream() << obj->checksumName();
  ad->stream() << obj->checksum();
  ad->stream() << obj->compressedFileSize();
  ad->stream() << obj->blockId0();
  ad->stream() << obj->blockId1();
  ad->stream() << obj->blockId2();
  ad->stream() << obj->blockId3();
  ad->stream() << obj->id();
  ad->stream() << obj->positionCommandCode();
}

//------------------------------------------------------------------------------
// createObj
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamFileMigratedNotificationStructCnv::createObj(castor::IAddress* address)
  throw (castor::exception::Exception) {
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  // create the new Object
  castor::tape::tapegateway::FileMigratedNotificationStruct* object = new castor::tape::tapegateway::FileMigratedNotificationStruct();
  // Now retrieve and set members
  u_signed64 fileTransactionId;
  ad->stream() >> fileTransactionId;
  object->setFileTransactionId(fileTransactionId);
  std::string nshost;
  ad->stream() >> nshost;
  object->setNshost(nshost);
  u_signed64 fileid;
  ad->stream() >> fileid;
  object->setFileid(fileid);
  int fseq;
  ad->stream() >> fseq;
  object->setFseq(fseq);
  u_signed64 fileSize;
  ad->stream() >> fileSize;
  object->setFileSize(fileSize);
  std::string checksumName;
  ad->stream() >> checksumName;
  object->setChecksumName(checksumName);
  u_signed64 checksum;
  ad->stream() >> checksum;
  object->setChecksum(checksum);
  u_signed64 compressedFileSize;
  ad->stream() >> compressedFileSize;
  object->setCompressedFileSize(compressedFileSize);
  unsigned char blockId0;
  ad->stream() >> blockId0;
  object->setBlockId0(blockId0);
  unsigned char blockId1;
  ad->stream() >> blockId1;
  object->setBlockId1(blockId1);
  unsigned char blockId2;
  ad->stream() >> blockId2;
  object->setBlockId2(blockId2);
  unsigned char blockId3;
  ad->stream() >> blockId3;
  object->setBlockId3(blockId3);
  u_signed64 id;
  ad->stream() >> id;
  object->setId(id);
  int positionCommandCode;
  ad->stream() >> positionCommandCode;
  object->setPositionCommandCode((castor::tape::tapegateway::PositionCommandCode)positionCommandCode);
  return object;
}

//------------------------------------------------------------------------------
// marshalObject
//------------------------------------------------------------------------------
void castor::io::StreamFileMigratedNotificationStructCnv::marshalObject(castor::IObject* object,
                                                                        castor::io::StreamAddress* address,
                                                                        castor::ObjectSet& alreadyDone)
  throw (castor::exception::Exception) {
  castor::tape::tapegateway::FileMigratedNotificationStruct* obj = 
    dynamic_cast<castor::tape::tapegateway::FileMigratedNotificationStruct*>(object);
  if (0 == obj) {
    // Case of a null pointer
    address->stream() << castor::OBJ_Ptr << ((unsigned int)0);
  } else if (alreadyDone.find(obj) == alreadyDone.end()) {
    // Case of a pointer to a non streamed object
    createRep(address, obj, true);
    // Mark object as done
    alreadyDone.insert(obj);
    cnvSvc()->marshalObject(obj->fileMigrationReportList(), address, alreadyDone);
  } else {
    // case of a pointer to an already streamed object
    address->stream() << castor::OBJ_Ptr << alreadyDone[obj];
  }
}

//------------------------------------------------------------------------------
// unmarshalObject
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamFileMigratedNotificationStructCnv::unmarshalObject(castor::io::biniostream& stream,
                                                                                      castor::ObjectCatalog& newlyCreated)
  throw (castor::exception::Exception) {
  castor::io::StreamAddress ad(stream, "StreamCnvSvc", castor::SVC_STREAMCNV);
  castor::IObject* object = createObj(&ad);
  // Mark object as created
  newlyCreated.insert(object);
  // Fill object with associations
  castor::tape::tapegateway::FileMigratedNotificationStruct* obj = 
    dynamic_cast<castor::tape::tapegateway::FileMigratedNotificationStruct*>(object);
  ad.setObjType(castor::OBJ_INVALID);
  castor::IObject* objFileMigrationReportList = cnvSvc()->unmarshalObject(ad, newlyCreated);
  obj->setFileMigrationReportList(dynamic_cast<castor::tape::tapegateway::FileMigrationReportList*>(objFileMigrationReportList));
  return object;
}

