/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/io/StreamGetUpdateStartResponseCnv.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "StreamGetUpdateStartResponseCnv.hpp"
#include "castor/CnvFactory.hpp"
#include "castor/Constants.hpp"
#include "castor/IAddress.hpp"
#include "castor/ICnvSvc.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectCatalog.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/exception/Exception.hpp"
#include "castor/io/StreamAddress.hpp"
#include "castor/io/StreamBaseCnv.hpp"
#include "castor/io/StreamCnvSvc.hpp"
#include "castor/rh/GetUpdateStartResponse.hpp"
#include "castor/stager/DiskCopyForRecall.hpp"
#include "osdep.h"
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Instantiation of a static factory class - should never be used
//------------------------------------------------------------------------------
static castor::CnvFactory<castor::io::StreamGetUpdateStartResponseCnv>* s_factoryStreamGetUpdateStartResponseCnv =
  new castor::CnvFactory<castor::io::StreamGetUpdateStartResponseCnv>();

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::io::StreamGetUpdateStartResponseCnv::StreamGetUpdateStartResponseCnv(castor::ICnvSvc* cnvSvc) :
 StreamBaseCnv(cnvSvc) {}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::io::StreamGetUpdateStartResponseCnv::~StreamGetUpdateStartResponseCnv() throw() {
}

//------------------------------------------------------------------------------
// ObjType
//------------------------------------------------------------------------------
unsigned int castor::io::StreamGetUpdateStartResponseCnv::ObjType() {
  return castor::rh::GetUpdateStartResponse::TYPE();
}

//------------------------------------------------------------------------------
// objType
//------------------------------------------------------------------------------
unsigned int castor::io::StreamGetUpdateStartResponseCnv::objType() const {
  return ObjType();
}

//------------------------------------------------------------------------------
// createRep
//------------------------------------------------------------------------------
void castor::io::StreamGetUpdateStartResponseCnv::createRep(castor::IAddress* address,
                                                            castor::IObject* object,
                                                            bool,
                                                            unsigned int)
  throw (castor::exception::Exception) {
  castor::rh::GetUpdateStartResponse* obj = 
    dynamic_cast<castor::rh::GetUpdateStartResponse*>(object);
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  ad->stream() << obj->type();
  ad->stream() << obj->diskCopyPath();
  ad->stream() << obj->id();
  ad->stream() << obj->errorCode();
  ad->stream() << obj->errorMessage();
  ad->stream() << obj->reqAssociated();
  ad->stream() << obj->emptyFile();
}

//------------------------------------------------------------------------------
// createObj
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamGetUpdateStartResponseCnv::createObj(castor::IAddress* address)
  throw (castor::exception::Exception) {
  StreamAddress* ad = 
    dynamic_cast<StreamAddress*>(address);
  // create the new Object
  castor::rh::GetUpdateStartResponse* object = new castor::rh::GetUpdateStartResponse();
  // Now retrieve and set members
  std::string diskCopyPath;
  ad->stream() >> diskCopyPath;
  object->setDiskCopyPath(diskCopyPath);
  u_signed64 id;
  ad->stream() >> id;
  object->setId(id);
  unsigned int errorCode;
  ad->stream() >> errorCode;
  object->setErrorCode(errorCode);
  std::string errorMessage;
  ad->stream() >> errorMessage;
  object->setErrorMessage(errorMessage);
  std::string reqAssociated;
  ad->stream() >> reqAssociated;
  object->setReqAssociated(reqAssociated);
  bool emptyFile;
  ad->stream() >> emptyFile;
  object->setEmptyFile(emptyFile);
  return object;
}

//------------------------------------------------------------------------------
// marshalObject
//------------------------------------------------------------------------------
void castor::io::StreamGetUpdateStartResponseCnv::marshalObject(castor::IObject* object,
                                                                castor::io::StreamAddress* address,
                                                                castor::ObjectSet& alreadyDone)
  throw (castor::exception::Exception) {
  castor::rh::GetUpdateStartResponse* obj = 
    dynamic_cast<castor::rh::GetUpdateStartResponse*>(object);
  if (0 == obj) {
    // Case of a null pointer
    address->stream() << castor::OBJ_Ptr << ((unsigned int)0);
  } else if (alreadyDone.find(obj) == alreadyDone.end()) {
    // Case of a pointer to a non streamed object
    createRep(address, obj, true);
    // Mark object as done
    alreadyDone.insert(obj);
    address->stream() << obj->sources().size();
    for (std::vector<castor::stager::DiskCopyForRecall*>::iterator it = obj->sources().begin();
         it != obj->sources().end();
         it++) {
      cnvSvc()->marshalObject(*it, address, alreadyDone);
    }
  } else {
    // case of a pointer to an already streamed object
    address->stream() << castor::OBJ_Ptr << alreadyDone[obj];
  }
}

//------------------------------------------------------------------------------
// unmarshalObject
//------------------------------------------------------------------------------
castor::IObject* castor::io::StreamGetUpdateStartResponseCnv::unmarshalObject(castor::io::biniostream& stream,
                                                                              castor::ObjectCatalog& newlyCreated)
  throw (castor::exception::Exception) {
  castor::io::StreamAddress ad(stream, "StreamCnvSvc", castor::SVC_STREAMCNV);
  castor::IObject* object = createObj(&ad);
  // Mark object as created
  newlyCreated.insert(object);
  // Fill object with associations
  castor::rh::GetUpdateStartResponse* obj = 
    dynamic_cast<castor::rh::GetUpdateStartResponse*>(object);
  unsigned int sourcesNb;
  ad.stream() >> sourcesNb;
  for (unsigned int i = 0; i < sourcesNb; i++) {
    ad.setObjType(castor::OBJ_INVALID);
    castor::IObject* objSources = cnvSvc()->unmarshalObject(ad, newlyCreated);
    obj->addSources(dynamic_cast<castor::stager::DiskCopyForRecall*>(objSources));
  }
  return object;
}

