/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/query/FileSystemDescription.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/query/DiskServerDescription.hpp"
#include "castor/query/FileSystemDescription.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::query::FileSystemDescription::FileSystemDescription() throw() :
  m_mountPoint(""),
  m_freeSpace(0),
  m_totalSpace(0),
  m_reservedSpace(0),
  m_minFreeSpace(0.0),
  m_maxFreeSpace(0.0),
  m_status(0),
  m_id(0),
  m_diskServer(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::query::FileSystemDescription::~FileSystemDescription() throw() {
  if (0 != m_diskServer) {
    m_diskServer->removeFileSystems(this);
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::query::FileSystemDescription::print(std::ostream& stream,
                                                 std::string indent,
                                                 castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# FileSystemDescription #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Output of all members
  stream << indent << "mountPoint : " << m_mountPoint << std::endl;
  stream << indent << "freeSpace : " << m_freeSpace << std::endl;
  stream << indent << "totalSpace : " << m_totalSpace << std::endl;
  stream << indent << "reservedSpace : " << m_reservedSpace << std::endl;
  stream << indent << "minFreeSpace : " << m_minFreeSpace << std::endl;
  stream << indent << "maxFreeSpace : " << m_maxFreeSpace << std::endl;
  stream << indent << "status : " << m_status << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  stream << indent << "DiskServer : " << std::endl;
  if (0 != m_diskServer) {
    m_diskServer->print(stream, indent + "  ", alreadyPrinted);
  } else {
    stream << indent << "  null" << std::endl;
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::query::FileSystemDescription::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::query::FileSystemDescription::TYPE() {
  return OBJ_FileSystemDescription;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::query::FileSystemDescription::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::query::FileSystemDescription::clone() {
  return new FileSystemDescription(*this);
}

