/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/CastorFile.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_STAGER_CASTORFILE_HPP
#define CASTOR_STAGER_CASTORFILE_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace stager {

    // Forward declarations
    class FileClass;

    /**
     * class CastorFile
     * A castor file.
     */
    class CastorFile : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      CastorFile() throw();

      /**
       * Empty Destructor
       */
      virtual ~CastorFile() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_fileId
       * The id of this castor file. This identifies it uniquely
       * @return the value of m_fileId
       */
      u_signed64 fileId() const {
        return m_fileId;
      }

      /**
       * Set the value of m_fileId
       * The id of this castor file. This identifies it uniquely
       * @param new_var the new value of m_fileId
       */
      void setFileId(u_signed64 new_var) {
        m_fileId = new_var;
      }

      /**
       * Get the value of m_nsHost
       * The name server hosting this castor file
       * @return the value of m_nsHost
       */
      std::string nsHost() const {
        return m_nsHost;
      }

      /**
       * Set the value of m_nsHost
       * The name server hosting this castor file
       * @param new_var the new value of m_nsHost
       */
      void setNsHost(std::string new_var) {
        m_nsHost = new_var;
      }

      /**
       * Get the value of m_fileSize
       * Size of the file
       * @return the value of m_fileSize
       */
      u_signed64 fileSize() const {
        return m_fileSize;
      }

      /**
       * Set the value of m_fileSize
       * Size of the file
       * @param new_var the new value of m_fileSize
       */
      void setFileSize(u_signed64 new_var) {
        m_fileSize = new_var;
      }

      /**
       * Get the value of m_creationTime
       * Time when this instance of a CastorFile was created
       * @return the value of m_creationTime
       */
      u_signed64 creationTime() const {
        return m_creationTime;
      }

      /**
       * Set the value of m_creationTime
       * Time when this instance of a CastorFile was created
       * @param new_var the new value of m_creationTime
       */
      void setCreationTime(u_signed64 new_var) {
        m_creationTime = new_var;
      }

      /**
       * Get the value of m_lastAccessTime
       * Time of the last access to this CastorFile
       * @return the value of m_lastAccessTime
       */
      u_signed64 lastAccessTime() const {
        return m_lastAccessTime;
      }

      /**
       * Set the value of m_lastAccessTime
       * Time of the last access to this CastorFile
       * @param new_var the new value of m_lastAccessTime
       */
      void setLastAccessTime(u_signed64 new_var) {
        m_lastAccessTime = new_var;
      }

      /**
       * Get the value of m_lastKnownFileName
       * The name of the castorfile at the time it was created in this database. This can
       * very well be different from the current name if the file was renamed.
       * This information is only here for efficient and approximate querying. It should
       * never be used in processing. There, only the fileid/nshost couple is trustable
       * @return the value of m_lastKnownFileName
       */
      std::string lastKnownFileName() const {
        return m_lastKnownFileName;
      }

      /**
       * Set the value of m_lastKnownFileName
       * The name of the castorfile at the time it was created in this database. This can
       * very well be different from the current name if the file was renamed.
       * This information is only here for efficient and approximate querying. It should
       * never be used in processing. There, only the fileid/nshost couple is trustable
       * @param new_var the new value of m_lastKnownFileName
       */
      void setLastKnownFileName(std::string new_var) {
        m_lastKnownFileName = new_var;
      }

      /**
       * Get the value of m_lastUpdateTime
       * @return the value of m_lastUpdateTime
       */
      u_signed64 lastUpdateTime() const {
        return m_lastUpdateTime;
      }

      /**
       * Set the value of m_lastUpdateTime
       * @param new_var the new value of m_lastUpdateTime
       */
      void setLastUpdateTime(u_signed64 new_var) {
        m_lastUpdateTime = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Get the value of m_fileClass
       * @return the value of m_fileClass
       */
      FileClass* fileClass() const {
        return m_fileClass;
      }

      /**
       * Set the value of m_fileClass
       * @param new_var the new value of m_fileClass
       */
      void setFileClass(FileClass* new_var) {
        m_fileClass = new_var;
      }

    private:

      /// The id of this castor file. This identifies it uniquely
      u_signed64 m_fileId;

      /// The name server hosting this castor file
      std::string m_nsHost;

      /// Size of the file
      u_signed64 m_fileSize;

      /// Time when this instance of a CastorFile was created
      u_signed64 m_creationTime;

      /// Time of the last access to this CastorFile
      u_signed64 m_lastAccessTime;

      /*
       * The name of the castorfile at the time it was created in this database. This can very well be different from the current name if the file was renamed.
       * This information is only here for efficient and approximate querying. It should never be used in processing. There, only the fileid/nshost couple is trustable
      */
      std::string m_lastKnownFileName;

      u_signed64 m_lastUpdateTime;

      /// The id of this object
      u_signed64 m_id;

      FileClass* m_fileClass;

    }; /* end of class CastorFile */

  } /* end of namespace stager */

} /* end of namespace castor */

#endif // CASTOR_STAGER_CASTORFILE_HPP
