/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/FileErrorReportStruct.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_FILEERRORREPORTSTRUCT_HPP
#define CASTOR_TAPE_TAPEGATEWAY_FILEERRORREPORTSTRUCT_HPP

// Include Files
#include "castor/tape/tapegateway/BaseFileInfoStruct.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace tape {

    namespace tapegateway {

      // Forward declarations
      class FileRecallReportList;
      class FileMigrationReportList;

      /**
       * class FileErrorReportStruct
       */
      class FileErrorReportStruct : public virtual BaseFileInfoStruct {

      public:

        /**
         * Empty Constructor
         */
        FileErrorReportStruct() throw();

        /**
         * Empty Destructor
         */
        virtual ~FileErrorReportStruct() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Gets the type of this kind of objects
         */
        static int TYPE();

        /********************************************/
        /* Implementation of IObject abstract class */
        /********************************************/
        /**
         * Gets the type of the object
         */
        virtual int type() const;

        /**
         * virtual method to clone any object
         */
        virtual castor::IObject* clone();

        /*********************************/
        /* End of IObject abstract class */
        /*********************************/
        /**
         * Get the value of m_errorCode
         * @return the value of m_errorCode
         */
        int errorCode() const {
          return m_errorCode;
        }

        /**
         * Set the value of m_errorCode
         * @param new_var the new value of m_errorCode
         */
        void setErrorCode(int new_var) {
          m_errorCode = new_var;
        }

        /**
         * Get the value of m_errorMessage
         * @return the value of m_errorMessage
         */
        std::string errorMessage() const {
          return m_errorMessage;
        }

        /**
         * Set the value of m_errorMessage
         * @param new_var the new value of m_errorMessage
         */
        void setErrorMessage(std::string new_var) {
          m_errorMessage = new_var;
        }

        /**
         * Get the value of m_id
         * The id of this object
         * @return the value of m_id
         */
        u_signed64 id() const {
          return m_id;
        }

        /**
         * Set the value of m_id
         * The id of this object
         * @param new_var the new value of m_id
         */
        void setId(u_signed64 new_var) {
          m_id = new_var;
        }

        /**
         * Get the value of m_fileMigrationReportList
         * @return the value of m_fileMigrationReportList
         */
        FileMigrationReportList* fileMigrationReportList() const {
          return m_fileMigrationReportList;
        }

        /**
         * Set the value of m_fileMigrationReportList
         * @param new_var the new value of m_fileMigrationReportList
         */
        void setFileMigrationReportList(FileMigrationReportList* new_var) {
          m_fileMigrationReportList = new_var;
        }

        /**
         * Get the value of m_fileRecallReportList
         * @return the value of m_fileRecallReportList
         */
        FileRecallReportList* fileRecallReportList() const {
          return m_fileRecallReportList;
        }

        /**
         * Set the value of m_fileRecallReportList
         * @param new_var the new value of m_fileRecallReportList
         */
        void setFileRecallReportList(FileRecallReportList* new_var) {
          m_fileRecallReportList = new_var;
        }

      private:

        int m_errorCode;

        std::string m_errorMessage;

        /// The id of this object
        u_signed64 m_id;

        FileMigrationReportList* m_fileMigrationReportList;

        FileRecallReportList* m_fileRecallReportList;

      }; /* end of class FileErrorReportStruct */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_FILEERRORREPORTSTRUCT_HPP
