/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/FileMigrationReportList.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/tape/tapegateway/FileErrorReportStruct.hpp"
#include "castor/tape/tapegateway/FileMigratedNotificationStruct.hpp"
#include "castor/tape/tapegateway/FileMigrationReportList.hpp"
#include "castor/tape/tapegateway/GatewayMessage.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::tape::tapegateway::FileMigrationReportList::FileMigrationReportList() throw() :
  GatewayMessage(),
  m_fseqSet(false),
  m_fseq(0),
  m_id(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::tape::tapegateway::FileMigrationReportList::~FileMigrationReportList() throw() {
  for (unsigned int i = 0; i < m_successfulMigrationsVector.size(); i++) {
    m_successfulMigrationsVector[i]->setFileMigrationReportList(0);
    delete m_successfulMigrationsVector[i];
  }
  m_successfulMigrationsVector.clear();
  for (unsigned int i = 0; i < m_failedMigrationsVector.size(); i++) {
    m_failedMigrationsVector[i]->setFileMigrationReportList(0);
    delete m_failedMigrationsVector[i];
  }
  m_failedMigrationsVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::tape::tapegateway::FileMigrationReportList::print(std::ostream& stream,
                                                               std::string indent,
                                                               castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# FileMigrationReportList #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Call print on the parent class(es)
  this->GatewayMessage::print(stream, indent, alreadyPrinted);
  // Output of all members
  stream << indent << "fseqSet : " << (m_fseqSet ? "Yes" : "No") << std::endl;
  stream << indent << "fseq : " << m_fseq << std::endl;
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  {
    stream << indent << "SuccessfulMigrations : " << std::endl;
    int i;
    std::vector<FileMigratedNotificationStruct*>::const_iterator it;
    for (it = m_successfulMigrationsVector.begin(), i = 0;
         it != m_successfulMigrationsVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
  {
    stream << indent << "FailedMigrations : " << std::endl;
    int i;
    std::vector<FileErrorReportStruct*>::const_iterator it;
    for (it = m_failedMigrationsVector.begin(), i = 0;
         it != m_failedMigrationsVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::tape::tapegateway::FileMigrationReportList::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::tape::tapegateway::FileMigrationReportList::TYPE() {
  return OBJ_FileMigrationReportList;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::tape::tapegateway::FileMigrationReportList::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::tape::tapegateway::FileMigrationReportList::clone() {
  return new FileMigrationReportList(*this);
}

