/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/FileMigrationReportList.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_FILEMIGRATIONREPORTLIST_HPP
#define CASTOR_TAPE_TAPEGATEWAY_FILEMIGRATIONREPORTLIST_HPP

// Include Files
#include "castor/tape/tapegateway/GatewayMessage.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace tape {

    namespace tapegateway {

      // Forward declarations
      class FileMigratedNotificationStruct;
      class FileErrorReportStruct;

      /**
       * class FileMigrationReportList
       */
      class FileMigrationReportList : public virtual GatewayMessage {

      public:

        /**
         * Empty Constructor
         */
        FileMigrationReportList() throw();

        /**
         * Empty Destructor
         */
        virtual ~FileMigrationReportList() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Gets the type of this kind of objects
         */
        static int TYPE();

        /********************************************/
        /* Implementation of IObject abstract class */
        /********************************************/
        /**
         * Gets the type of the object
         */
        virtual int type() const;

        /**
         * virtual method to clone any object
         */
        virtual castor::IObject* clone();

        /*********************************/
        /* End of IObject abstract class */
        /*********************************/
        /**
         * Get the value of m_fseqSet
         * @return the value of m_fseqSet
         */
        bool fseqSet() const {
          return m_fseqSet;
        }

        /**
         * Set the value of m_fseqSet
         * @param new_var the new value of m_fseqSet
         */
        void setFseqSet(bool new_var) {
          m_fseqSet = new_var;
        }

        /**
         * Get the value of m_fseq
         * @return the value of m_fseq
         */
        int fseq() const {
          return m_fseq;
        }

        /**
         * Set the value of m_fseq
         * @param new_var the new value of m_fseq
         */
        void setFseq(int new_var) {
          m_fseq = new_var;
        }

        /**
         * Get the value of m_id
         * The id of this object
         * @return the value of m_id
         */
        u_signed64 id() const {
          return m_id;
        }

        /**
         * Set the value of m_id
         * The id of this object
         * @param new_var the new value of m_id
         */
        void setId(u_signed64 new_var) {
          m_id = new_var;
        }

        /**
         * Add a FileMigratedNotificationStruct* object to the m_successfulMigrationsVector
         * list
         */
        void addSuccessfulMigrations(FileMigratedNotificationStruct* add_object) {
          m_successfulMigrationsVector.push_back(add_object);
        }

        /**
         * Remove a FileMigratedNotificationStruct* object from
         * m_successfulMigrationsVector
         */
        void removeSuccessfulMigrations(FileMigratedNotificationStruct* remove_object) {
          for (unsigned int i = 0; i < m_successfulMigrationsVector.size(); i++) {
            FileMigratedNotificationStruct* item = m_successfulMigrationsVector[i];
            if (item == remove_object) {
              std::vector<FileMigratedNotificationStruct*>::iterator it = m_successfulMigrationsVector.begin() + i;
              m_successfulMigrationsVector.erase(it);
              return;
            }
          }
        }

        /**
         * Get the list of FileMigratedNotificationStruct* objects held by
         * m_successfulMigrationsVector
         * @return list of FileMigratedNotificationStruct* objects held by
         * m_successfulMigrationsVector
         */
        std::vector<FileMigratedNotificationStruct*>& successfulMigrations() {
          return m_successfulMigrationsVector;
        }

        /**
         * Add a FileErrorReportStruct* object to the m_failedMigrationsVector list
         */
        void addFailedMigrations(FileErrorReportStruct* add_object) {
          m_failedMigrationsVector.push_back(add_object);
        }

        /**
         * Remove a FileErrorReportStruct* object from m_failedMigrationsVector
         */
        void removeFailedMigrations(FileErrorReportStruct* remove_object) {
          for (unsigned int i = 0; i < m_failedMigrationsVector.size(); i++) {
            FileErrorReportStruct* item = m_failedMigrationsVector[i];
            if (item == remove_object) {
              std::vector<FileErrorReportStruct*>::iterator it = m_failedMigrationsVector.begin() + i;
              m_failedMigrationsVector.erase(it);
              return;
            }
          }
        }

        /**
         * Get the list of FileErrorReportStruct* objects held by m_failedMigrationsVector
         * @return list of FileErrorReportStruct* objects held by m_failedMigrationsVector
         */
        std::vector<FileErrorReportStruct*>& failedMigrations() {
          return m_failedMigrationsVector;
        }

      private:

        bool m_fseqSet;

        int m_fseq;

        /// The id of this object
        u_signed64 m_id;

        std::vector<FileMigratedNotificationStruct*> m_successfulMigrationsVector;

        std::vector<FileErrorReportStruct*> m_failedMigrationsVector;

      }; /* end of class FileMigrationReportList */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_FILEMIGRATIONREPORTLIST_HPP
