/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/FileRecallReportList.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_FILERECALLREPORTLIST_HPP
#define CASTOR_TAPE_TAPEGATEWAY_FILERECALLREPORTLIST_HPP

// Include Files
#include "castor/tape/tapegateway/GatewayMessage.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace tape {

    namespace tapegateway {

      // Forward declarations
      class FileRecalledNotificationStruct;
      class FileErrorReportStruct;

      /**
       * class FileRecallReportList
       */
      class FileRecallReportList : public virtual GatewayMessage {

      public:

        /**
         * Empty Constructor
         */
        FileRecallReportList() throw();

        /**
         * Empty Destructor
         */
        virtual ~FileRecallReportList() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Gets the type of this kind of objects
         */
        static int TYPE();

        /********************************************/
        /* Implementation of IObject abstract class */
        /********************************************/
        /**
         * Gets the type of the object
         */
        virtual int type() const;

        /**
         * virtual method to clone any object
         */
        virtual castor::IObject* clone();

        /*********************************/
        /* End of IObject abstract class */
        /*********************************/
        /**
         * Get the value of m_id
         * The id of this object
         * @return the value of m_id
         */
        u_signed64 id() const {
          return m_id;
        }

        /**
         * Set the value of m_id
         * The id of this object
         * @param new_var the new value of m_id
         */
        void setId(u_signed64 new_var) {
          m_id = new_var;
        }

        /**
         * Add a FileRecalledNotificationStruct* object to the m_successfulRecallsVector
         * list
         */
        void addSuccessfulRecalls(FileRecalledNotificationStruct* add_object) {
          m_successfulRecallsVector.push_back(add_object);
        }

        /**
         * Remove a FileRecalledNotificationStruct* object from m_successfulRecallsVector
         */
        void removeSuccessfulRecalls(FileRecalledNotificationStruct* remove_object) {
          for (unsigned int i = 0; i < m_successfulRecallsVector.size(); i++) {
            FileRecalledNotificationStruct* item = m_successfulRecallsVector[i];
            if (item == remove_object) {
              std::vector<FileRecalledNotificationStruct*>::iterator it = m_successfulRecallsVector.begin() + i;
              m_successfulRecallsVector.erase(it);
              return;
            }
          }
        }

        /**
         * Get the list of FileRecalledNotificationStruct* objects held by
         * m_successfulRecallsVector
         * @return list of FileRecalledNotificationStruct* objects held by
         * m_successfulRecallsVector
         */
        std::vector<FileRecalledNotificationStruct*>& successfulRecalls() {
          return m_successfulRecallsVector;
        }

        /**
         * Add a FileErrorReportStruct* object to the m_failedRecallsVector list
         */
        void addFailedRecalls(FileErrorReportStruct* add_object) {
          m_failedRecallsVector.push_back(add_object);
        }

        /**
         * Remove a FileErrorReportStruct* object from m_failedRecallsVector
         */
        void removeFailedRecalls(FileErrorReportStruct* remove_object) {
          for (unsigned int i = 0; i < m_failedRecallsVector.size(); i++) {
            FileErrorReportStruct* item = m_failedRecallsVector[i];
            if (item == remove_object) {
              std::vector<FileErrorReportStruct*>::iterator it = m_failedRecallsVector.begin() + i;
              m_failedRecallsVector.erase(it);
              return;
            }
          }
        }

        /**
         * Get the list of FileErrorReportStruct* objects held by m_failedRecallsVector
         * @return list of FileErrorReportStruct* objects held by m_failedRecallsVector
         */
        std::vector<FileErrorReportStruct*>& failedRecalls() {
          return m_failedRecallsVector;
        }

      private:

        /// The id of this object
        u_signed64 m_id;

        std::vector<FileRecalledNotificationStruct*> m_successfulRecallsVector;

        std::vector<FileErrorReportStruct*> m_failedRecallsVector;

      }; /* end of class FileRecallReportList */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_FILERECALLREPORTLIST_HPP
