/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/FileToMigrateStruct.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_FILETOMIGRATESTRUCT_HPP
#define CASTOR_TAPE_TAPEGATEWAY_FILETOMIGRATESTRUCT_HPP

// Include Files
#include "castor/tape/tapegateway/BaseFileInfoStruct.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace tape {

    namespace tapegateway {

      // Forward declarations
      class FilesToMigrateList;

      /**
       * class FileToMigrateStruct
       */
      class FileToMigrateStruct : public virtual BaseFileInfoStruct {

      public:

        /**
         * Empty Constructor
         */
        FileToMigrateStruct() throw();

        /**
         * Empty Destructor
         */
        virtual ~FileToMigrateStruct() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Gets the type of this kind of objects
         */
        static int TYPE();

        /********************************************/
        /* Implementation of IObject abstract class */
        /********************************************/
        /**
         * Gets the type of the object
         */
        virtual int type() const;

        /**
         * virtual method to clone any object
         */
        virtual castor::IObject* clone();

        /*********************************/
        /* End of IObject abstract class */
        /*********************************/
        /**
         * Get the value of m_fileSize
         * @return the value of m_fileSize
         */
        u_signed64 fileSize() const {
          return m_fileSize;
        }

        /**
         * Set the value of m_fileSize
         * @param new_var the new value of m_fileSize
         */
        void setFileSize(u_signed64 new_var) {
          m_fileSize = new_var;
        }

        /**
         * Get the value of m_lastKnownFilename
         * @return the value of m_lastKnownFilename
         */
        std::string lastKnownFilename() const {
          return m_lastKnownFilename;
        }

        /**
         * Set the value of m_lastKnownFilename
         * @param new_var the new value of m_lastKnownFilename
         */
        void setLastKnownFilename(std::string new_var) {
          m_lastKnownFilename = new_var;
        }

        /**
         * Get the value of m_lastModificationTime
         * @return the value of m_lastModificationTime
         */
        u_signed64 lastModificationTime() const {
          return m_lastModificationTime;
        }

        /**
         * Set the value of m_lastModificationTime
         * @param new_var the new value of m_lastModificationTime
         */
        void setLastModificationTime(u_signed64 new_var) {
          m_lastModificationTime = new_var;
        }

        /**
         * Get the value of m_path
         * @return the value of m_path
         */
        std::string path() const {
          return m_path;
        }

        /**
         * Set the value of m_path
         * @param new_var the new value of m_path
         */
        void setPath(std::string new_var) {
          m_path = new_var;
        }

        /**
         * Get the value of m_umask
         * @return the value of m_umask
         */
        int umask() const {
          return m_umask;
        }

        /**
         * Set the value of m_umask
         * @param new_var the new value of m_umask
         */
        void setUmask(int new_var) {
          m_umask = new_var;
        }

        /**
         * Get the value of m_id
         * The id of this object
         * @return the value of m_id
         */
        u_signed64 id() const {
          return m_id;
        }

        /**
         * Set the value of m_id
         * The id of this object
         * @param new_var the new value of m_id
         */
        void setId(u_signed64 new_var) {
          m_id = new_var;
        }

        /**
         * Get the value of m_filesToMigrateList
         * @return the value of m_filesToMigrateList
         */
        FilesToMigrateList* filesToMigrateList() const {
          return m_filesToMigrateList;
        }

        /**
         * Set the value of m_filesToMigrateList
         * @param new_var the new value of m_filesToMigrateList
         */
        void setFilesToMigrateList(FilesToMigrateList* new_var) {
          m_filesToMigrateList = new_var;
        }

      private:

        u_signed64 m_fileSize;

        std::string m_lastKnownFilename;

        u_signed64 m_lastModificationTime;

        std::string m_path;

        int m_umask;

        /// The id of this object
        u_signed64 m_id;

        FilesToMigrateList* m_filesToMigrateList;

      }; /* end of class FileToMigrateStruct */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_FILETOMIGRATESTRUCT_HPP
