/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/tape/tapegateway/GatewayMessage.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_TAPE_TAPEGATEWAY_GATEWAYMESSAGE_HPP
#define CASTOR_TAPE_TAPEGATEWAY_GATEWAYMESSAGE_HPP

// Include Files
#include "castor/IObject.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace tape {

    namespace tapegateway {

      /**
       * class GatewayMessage
       */
      class GatewayMessage : public virtual castor::IObject {

      public:

        /**
         * Empty Constructor
         */
        GatewayMessage() throw();

        /**
         * Empty Destructor
         */
        virtual ~GatewayMessage() throw();

        /**
         * Outputs this object in a human readable format
         * @param stream The stream where to print this object
         * @param indent The indentation to use
         * @param alreadyPrinted The set of objects already printed.
         * This is to avoid looping when printing circular dependencies
         */
        virtual void print(std::ostream& stream,
                           std::string indent,
                           castor::ObjectSet& alreadyPrinted) const;

        /**
         * Outputs this object in a human readable format
         */
        virtual void print() const;

        /**
         * Get the value of m_mountTransactionId
         * @return the value of m_mountTransactionId
         */
        u_signed64 mountTransactionId() const {
          return m_mountTransactionId;
        }

        /**
         * Set the value of m_mountTransactionId
         * @param new_var the new value of m_mountTransactionId
         */
        void setMountTransactionId(u_signed64 new_var) {
          m_mountTransactionId = new_var;
        }

        /**
         * Get the value of m_aggregatorTransactionId
         * @return the value of m_aggregatorTransactionId
         */
        u_signed64 aggregatorTransactionId() const {
          return m_aggregatorTransactionId;
        }

        /**
         * Set the value of m_aggregatorTransactionId
         * @param new_var the new value of m_aggregatorTransactionId
         */
        void setAggregatorTransactionId(u_signed64 new_var) {
          m_aggregatorTransactionId = new_var;
        }

      private:

        u_signed64 m_mountTransactionId;

        u_signed64 m_aggregatorTransactionId;

      }; /* end of class GatewayMessage */

    } /* end of namespace tapegateway */

  } /* end of namespace tape */

} /* end of namespace castor */

#endif // CASTOR_TAPE_TAPEGATEWAY_GATEWAYMESSAGE_HPP
